<?php
/**
* @version 			SEBLOD 3.x Core
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2013 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

defined( '_JEXEC' ) or die;

// Plugin
class plgCCK_Field_LinkContent_menu_dynamic extends JCckPluginLink
{
	protected static $type	=	'content_menu_dynamic';
	
	// -------- -------- -------- -------- -------- -------- -------- -------- // Prepare
	
	// onCCK_Field_LinkPrepareContent
	public static function onCCK_Field_LinkPrepareContent( &$field, &$config = array() )
	{		
		if ( self::$type != $field->link ) {
			return;
		}
		
		
		// Prepare
		$link	=	parent::g_getLink( $field->link_options );

		// Set
		$field->link	=	'';
		self::_link( $link, $field, $config );
	}
	
	// _link
	protected static function _link( $link, &$field, &$config )
	{
		$app		=	JFactory::getApplication();
		$sef		=	$link->get( 'sef', $config['doSEF'] );
		
		if ( !JFactory::getApplication()->getCfg( 'sef' ) ) {
			$sef	=	0;
		}
		$itemId		=	( $sef ) ? $link->get( 'itemid', '' ) : '';
		$content	=	$link->get( 'content', '' );
		$custom		=	$link->get( 'custom', '' );
		
		// Prepare
		if ( !$itemId ) {
			$view	=	$app->input->get( 'view', '' );
			$layout	=	$app->input->get( 'layout', '' );
			if ( ( $view == 'category' && $layout == 'blog' ) || $view == 'featured' ) {
				$sef	=	0;
			}
			if ( $sef ) {
				$itemId		=	$app->input->getInt( 'Itemid', 0 );
			}
		}
		
		
		$link_class			=	$link->get( 'class', '' );
		$link_rel			=	$link->get( 'rel', '' );
		$link_target		=	$link->get( 'target', '' );
		$tmpl				=	$link->get( 'tmpl', '' );
		$tmpl				=	$tmpl ? 'tmpl='.$tmpl : '';
		$vars				=	$tmpl;
		$custom				=	parent::g_getCustomVars( self::$type, $field, $custom, $config );
		
		if ( $content == '2' && $sef ||  $field->name=='art_id' && $sef) {
			$field->link	=	'';
			parent::g_addProcess( 'beforeRenderContent', self::$type, $config, array( 'name'=>$field->name, 'fieldname'=>$link->get( 'content_fieldname', '' ),'defaultvalue'=>$link->get('defaultvalue'), 'multilang'=>$link->get( 'bool3', '' ),'dynamic'=>$link->get( 'bool4', '' ),'isregex'=>$link->get( 'isregex', true ), 'itemId'=>$itemId, 'location'=>$link->get( 'content_location', $config['location'] ), 'sef'=>$sef, 'vars'=>$vars, 'custom'=>$custom ) );
		}
		
		// Set
		$field->link		=	( $config['location'] ) ? JCck::callFunc_Array( 'plgCCK_Storage_Location'.$config['location'], 'getRouteByStorage', array( &$config['storages'], $sef, $itemId, $config ) ) : '';

		$fieldname = $link->get( 'content_fieldname', '' );
		
		parent::g_addProcess( 'beforeRenderContent', self::$type, $config, array(
				'name'			=>	$field->name,
				'fieldname'		=>	$fieldname,
				'code'			=>	!$link->get('bool',0),
				'isFCode'		=>	$link->get('isFcode',0),
				'freeCode'		=>	$link->get('freeCode',''),
				'fileCode'		=>	$link->get('fileCode',''),
				'defaultvalue'	=>	$link->get('defaultvalue'),
				'multilang'		=>	$link->get('bool3',''),
				'dynamic'		=>	$link->get( 'bool4', '' ),
				'fsave'			=>	$link->get( 'fsave', false ),
				'isregex'		=>	$link->get( 'isregex', true ), 
				'itemId'		=>	$itemId, 
				'location'		=>	$link->get( 'content_location', $config['location'] ), 
				'sef'			=>	$sef, 
				'vars'			=>	$vars, 
				'custom'		=>	$custom 
				) );

		
		if ( $field->link ) {
			if ( $vars ) {
				$field->link	.=	( strpos( $field->link, '?' ) !== false ) ? '&'.$vars : '?'.$vars;
			}
			if ( $custom ) {
				$field->link	.=	( $custom[0] == '#' ) ? $custom : ( ( strpos( $field->link, '?' ) !== false ) ? '&'.$custom : '?'.$custom );
			}
		}
		if ( $app->isAdmin() ) {
			$field->link	=	str_replace( '/administrator', '', $field->link );
		}
		$field->link_class	=	$link_class ? $link_class : ( isset( $field->link_class ) ? $field->link_class : '' );
		$field->link_rel	=	$link_rel ? $link_rel : ( isset( $field->link_rel ) ? $field->link_rel : '' );
		$field->link_target	=	$link_target ? $link_target : ( isset( $field->link_target ) ? $field->link_target : '' );
	}

	// -------- -------- -------- -------- -------- -------- -------- -------- // Special Events
	
	// onCCK_Field_LinkBeforeRenderContent
	public static function onCCK_Field_LinkBeforeRenderContent( $process, &$fields, &$storages, &$config = array() )
	{
		$name		=	$process['name'];
		$fieldname	=	$process['fieldname'];
		$location	=	$process['location'];
		$dynamic	=	$process['dynamic'];
		$multiLang	=	$process['multilang'];
		$isRegex	=	$process['isregex'];
		$fsave		=	$process['fsave'];
		$defaultvalue=	$process['defaultvalue'];
	
		$code		=	$process['code'];
		$isFCode	=	$process['isFCode'];
		$freeCode	=	$process['freeCode'];
		$files	=	$process['fileCode'];
		
		if($multiLang){	
			$sefLang = JLanguageHelper::getLanguages('lang_code')[JFactory::getLanguage()->getTag()]->sef;
		}

		$pk = $config['pk'];
		$type = $config['type'];
		
		if ( !$pk ) {
			if ( count( $process['matches'][1] ) ) {
				parent::g_setCustomVars( $process, $fields, $name );
			}
			return;
		}
		
		if($dynamic){
			$process['itemId'] = null;
			
			if($code){
				if($isFCode){
					$files = explode("||",$files);
					foreach ( $files as $file ) {
						if ( is_file( JPATH_SITE.'/'.$file ) ) {
							include JPATH_SITE.'/'.$file;
						}
					}
				}else{
					eval($freeCode);
				}
				if(isset($link)){
					$fields[$name]->link = $link;
				}
				if(isset($itemIdMenu))
					$process['itemId'] = $itemIdMenu;
			}else{
				$lang=& JFactory::getLanguage();
				$langTag = $lang->getTag();
				$langBeforeLink = '';
				
				if($multiLang){
					$where=' and language="'.$langTag.'"';
				}
				else
					$where='';
				
				$db		=	JFactory::getDBO();
				
				//$idContent=$fields[$fieldname]->value;
				$idContent=$pk;
				
				// here we check if it's a fsave or not, and, if it's a yes, we get the default value from the file, same for the code Field
				if($fsave){
					$conf = self::_getCustomConf();
				}else{
					$menus=$defaultvalue;
				}
					
				$query	=	'select id, catid, alias, language, introtext from #__content WHERE id='.$idContent;
				$db->setQuery( $query );
				$result=$db->loadObjectList();
				$content=$result[0];
				
				$fields[$name]->link = '';
				// first we search if there's a direct link to the specific content 
	// 			if(empty($fields[$name]->link)){
					
				if( $isRegex ){
					$regex = ' REGEXP "(.*)index\.php[?]option=com\_(content|cck)&view=article&id='.$content->id.'(&{1}.*)*$" ';
					$query  =       'select id from #__menu WHERE published=1 and link '.$regex.' '.$where;
					$db->setQuery( $query );
					$result=$db->loadResult();
				}else{
	
					$query	=	'select id from #__menu WHERE published=1 and link="index.php?option=com_cck&view=article&id='.$content->id.'"'.$where;
					$db->setQuery( $query );
					$result=$db->loadResult();

					if(!$result){
						$query	=	'select id from #__menu WHERE published=1 and link LIKE "%index.php?option=com_content&view=article&id='.$content->id.'" '.$where;
						$db->setQuery( $query );
						$result=$db->loadResult();
					}
				}
				if($result){
					$process['itemId']	= $result;
// 					$link = $result[0]->path; 
// 					$link = $multiLang ? ( $sefLang.'/'.$link ) : $link;
// 					$fields[$name]->link	=	$link;
				}
						
				// if still not found we search with the specific case
				if(empty($process['itemId'])){
					
					$arrayMenus=json_decode($menus);
					
					if(!function_exists('setAttr')){				
	                              		function setAttr($record)
	                                	{	
							$arrayCorresp = array('cT'=>'contentType','ff'=>'filter_field','ffv'=>'filter_field_value','sId'=>'selectId','gu'=>'groupUser','iId'=>'itemId');
	                                        	$return = new StdClass();
	                                        	foreach($arrayCorresp as $index=>$corr){
								if(isset($record->$index)){
									$changed = true;
	                                        	        	$return->$corr = $record->$index;
								}
	                                        	}
							$return = $changed ? $return : $record;
	                                        	return $return;
	                                	}
					}

					$arrayMenus = array_map('setAttr',$arrayMenus);
					
					$resultCck = $config['type'];
					
					$language=$content->language;
	
					$lang = JFactory::getLanguage();
					JLoader::register('MenusHelper', JPATH_ADMINISTRATOR . '/components/com_menus/helpers/menus.php');
					
					$user = JFactory::getUser();		
					foreach($arrayMenus as $menu){
						
						$groupUser=$menu->groupUser;
	
						if($process['itemId'])
							continue;
						
						if($resultCck==$menu->contentType){
							if($groupUser != 0 && !in_array($groupUser, $user->getAuthorisedGroups()))
								continue;
						
							
							if(!$found){//jeremie
								if( !empty($menu->filter_field) && !empty($menu->filter_field_value) ){
									
									JPluginHelper::importPlugin( 'cck_field' );
									JPluginHelper::importPlugin( 'cck_field_restriction' );
									JPluginHelper::importPlugin( 'cck_storage_location' );
									
									$query =	'SELECT a.* FROM #__cck_core_fields as a WHERE a.name LIKE "'.$menu->filter_field.'"';
									$field	=	JCckDatabase::loadObject($query);
									$value = '';
									$Pt		=	$field->storage_table;
									$config['storages'][$Pt]	=	'';
					
									$dispatcher	=	JDispatcher::getInstance();
									
									$dispatcher->trigger( 'onCCK_Storage_LocationPrepareForm', array( &$field, &$config['storages'][$Pt], $idContent, &$config ) );
									
									$value = '';
									$dispatcher->trigger( 'onCCK_StoragePrepareContent', array( &$field, &$value, &$config['storages'][$Pt] ) );
									if ( is_string( $value ) ) {
										$value		=	trim( $value );
									}
									$values = explode(',', $value);
									
									if(!in_array($menu->filter_field_value, $values))
										continue;
								}
							}//jeremie
											
							$itemIdMenu=$menu->itemId;

							if(!$itemIdMenu)
								continue;
							else{
								$process['itemId'] = $itemIdMenu;
								// set rewrite url sef from menu
								$process['sef'] = $menu->selectId == '' ? $config['doSEF'] : $menu->selectId ;
							}
						}				
					}
				}
					
				// echo $fields[$name]->link.' <br/>';
				// end content_menu_cck
				
				// if still not found, we search in the article and liste from categories
				if(empty($process['itemId'])){
					
					$lang=& JFactory::getLanguage();
					$langTag = $lang->getTag();
					if($multiLang)
						$where=' and language="'.$langTag.'"';
					else
						$where='';
						
					$db		=	JFactory::getDBO();
	
					$query	=	'select catid from #__content WHERE id='.$config['pk'];
					$db->setQuery( $query );
					$catid	=	$db->loadResult();
					$query	=	'select id from #__menu WHERE published=1 and link="index.php?option=com_content&view=article&id='.$config['pk'].'"'.$where;
					$db->setQuery( $query );
					$result=$db->loadResult();
					if(!$result){
						$query	=	'select id from #__menu WHERE published=1 and ( link LIKE "%index.php?option=com_content&view=category&id='.$catid.'%" OR link LIKE "%index.php?option=com_content&view=category&layout=blog&id='.$catid.'%") '.$where;
						$db->setQuery( $query );
						$result=$db->loadResult();
					}
	
					if($result){
						$process['itemId'] = $result;
					}
						
				}
			}

			
			
			
			/*
				$itemIdMenu = $fields[$name]->itemIdMenu;
				$fields[$name]->link	=	JCck::callFunc_Array( 'plgCCK_Storage_Location'.$location, 'getRoute', array( $pk, $process['sef'], $process['itemId'], $config ) );
				
				// get content alias
				
				
				$query	=	'select alias, parent_id from #__menu WHERE id='.$itemIdMenu;
				$db->setQuery( $query );
				$result=$db->loadObjectList();
				
				$parent_id=$result[0]->parent_id;
				
				
				// do not know if that's gonna be used or not, anyway, that's here ;)
				if($sef==23 || $sef=24 || $menu->selectId ==2)
					$aliasUrl='';
				else
					$aliasUrl=$config['pk'].'-';
				if($menu->selectId ==1)
					$aliasUrl=$config['pk'].'-';
					
				$fields[$name]->link	=	$result[0]->alias.'/'.$aliasUrl.$content->alias;
				while($parent_id!=1 && count($result)>0){
					$returns=self::getItemMenu($parent_id);
					$fields[$name]->link	=	$returns[0]->alias.'/'.$fields[$name]->link;
					$parent_id=$returns[0]->parent_id;
				}
				$fields[$name]->link	= $multiLang ? ( '/'.$sefLang.'/'.$fields[$name]->link ) : $fields[$name]->link;
			}elseif(empty($fields[$name]->link)){
				// for now take the current link and add the alias, no better idea >___<
				$uri = JURI::getInstance();
				$link = JURI::getInstance()->getPath().'/'.$content->alias;
				$fields[$name]->link = $link;
			}
			
			
					
					
					
			// test joachim plugin typo compatible
			/*
			if($name=='art_id'){
				$value=$fields['art_id']->value;
				$devenir=str_replace($fields['art_id']->value.'<', $html.'<', $fields['art_id']->html);
				$fields['art_id']->html=$devenir;
			}
			
			if ( count( $process['matches'][1] ) ) {
				parent::g_setCustomVars( $process, $fields, $name );
			}
			
			*/	
		}else{
			if($fieldname){
				$pk		=	isset( $fields[$fieldname] ) ? (int)$fields[$fieldname]->value : 0;
			}
		}
		
		// here i do not know if sef is used or not, may be hwill have to add it later,... ( up it's not deleted for this specific reason )
		if( $process['itemId'] ){
			if($multiLang){
				$associations = MenusHelper::getAssociations($process['itemId']);
				if(array_key_exists(JFactory::getLanguage()->getTag(),$associations)){
					$process['itemId'] = $associations[JFactory::getLanguage()->getTag()];
				}
			} 
			$fields[$name]->link	=	JCck::callFunc_Array( 'plgCCK_Storage_Location'.$location, 'getRoute', array( $pk, $process['sef'], $process['itemId'], $config ) );
		}elseif(empty($fields[$name]->link)){
			// for now take the current link and add the alias, no better idea >___<
			$uri = JURI::getInstance();
			$link = JURI::getInstance()->getPath().'/'.$content->alias;
			$fields[$name]->link = $link;
		}
		
		
		$target	=	$fields[$name]->typo_target;
		if ( $fields[$name]->link ) {
			if ( $process['vars'] ) {
				$fields[$name]->link	.=	( strpos( $fields[$name]->link, '?' ) !== false ) ? '&'.$process['vars'] : '?'.$process['vars'];
			}
			if ( $process['custom'] ) {
				$fields[$name]->link	.=	( $process['custom'][0] == '#' ) ? $process['custom'] : ( ( strpos( $fields[$name]->link, '?' ) !== false ) ? '&'.$process['custom'] : '?'.$process['custom'] );
			}
		
			$link = $fields[$name]->link;
		
			// check for a href balise, custom gege regex powa !!! =>
			//$pattern =  '~^<a(?:\s+)href=["|\'](?:.*)[\'|"]>(.*)</a>~';
			$pattern =  '~(?<before>.*)<a(?:\s+)href=["|\'](?:.*)[\'|"]>(?<label>.*)</a>(?<after>.*)~';
			preg_match($pattern,$fields[$name]->$target,$matches);
				
			if(count($matches)){
				$fields[$name]->$target = $matches['before']."<a href=\"$link\">".$matches['label']."</a>".$matches['after'];
				//$fields[$name]->$target = preg_replace($pattern, "$1",$fields[$name]->$target);
			}
				
			if ( $fields[$name]->typo ) {
				preg_match($pattern,$fields[$name]->typo,$matches);
				if(count($matches)){
					$fields[$name]->typo = $matches['before']."<a href=\"$link\">".$matches['label']."</a>".$matches['after'];
				}
			}		
			JCckPluginLink::g_setHtml( $fields[$name], $target );
		}
		if ( count( $process['matches'][1] ) ) {
			parent::g_setCustomVars( $process, $fields, $name );
		}
		
		
		// echo $fields[$name]->link.' <br/>';
// 		var_dump($target);
// 		var_dump($fields[$name]);die();
	}
	
	// _goto
	protected static function _goTo( $itemId )
	{
		$menu	=	JFactory::getApplication()->getMenu();
		$item	=	$menu->getItem( $itemId );
		$search	=	$item->query['search'];

		$items	=	self::_gotoItems( $search, $itemId );
	}
	
	public static function getItemMenu($idMenu)
	{
		$db		=	JFactory::getDBO();
		$query	=	'select alias, parent_id from #__menu WHERE published=1 and id='.$idMenu;
		$db->setQuery( $query );
		return $result=$db->loadObjectList();
	}

	// _goToItems
	protected static function _goToItems( $search, $itemId )
	{
		static $items				=	array();
		$goto						=	$search.'_'.$itemId;

		if ( !isset( $items[$goto] ) ) {
			$class_sfx					=	'';
			
			$uniqId						=	'f'.$field->id;
			$formId						=	'seblod_list_'.$uniqId;
			
			$preconfig					=	array();
			$preconfig['action']		=	'';
			$preconfig['client']		=	'search';
			$preconfig['formId']		=	$formId;
			$preconfig['submit']		=	'JCck.Core.submit_'.$uniqId;
			$preconfig['search']		=	$search;
			$preconfig['itemId']		=	$itemId;
			$preconfig['task']			=	'search';
			$preconfig['show_form']		=	0;
			$preconfig['show_list']		=	0;
			$preconfig['auto_redirect']	=	0;
			$preconfig['limit2']		=	0; // todo
			$preconfig['ordering']		=	''; // todo
			$preconfig['ordering2']		=	''; // todo
			
			$live						=	'';
			$variation					=	'';
			$limitstart					=	-1;
			
			$params						=	new JRegistry;	// todo : remove+inherit?
			$params->set( 'order_by', '' );
			require_once JPATH_SITE.'/components/com_cck/helpers/helper_define.php';
			require_once JPATH_SITE.'/components/com_cck/helpers/helper_include.php';
			
			// Prepare
			jimport( 'cck.base.list.list' );
			include JPATH_SITE.'/libraries/cck/base/list/list_inc.php';

			$items[$goto]	=	$items;
		}

		return $items[$goto];
	}
	
	protected static function _getConfPath($view,$fieldid,$viewid)
	{
		$path = dirname(__FILE__).DIRECTORY_SEPARATOR.'confs';
		if(!is_dir($path)){
			mkdir($path);
		}
		$path .= DIRECTORY_SEPARATOR.$view.'_'.$fieldid.'_'.$viewid;
		return $path;
	}

	public function onAjaxContent_menu_dynamic()
	{
		$task = JRequest::getVar('task', "");
		$view = JRequest::getVar('view', "");
		$fieldId = JRequest::getVar('fieldId', "");
		$viewId = (int)JRequest::getVar('viewId', 0);
		
		$currentClass = get_class($this);
		if(method_exists($currentClass, $task)){
			$value = $currentClass::$task($view,$fieldId,$viewId);
		}else{
			$value = null;
		}
		return $value;
	}
	
	protected static function _setCustomConf($view,$fieldid,$viewid)
	{
		$custConf = JRequest::getVar('conf', "");
		$path = self::_getConfPath($view,$fieldid,$viewid);
		$handle = fopen($path, 'w');
		fwrite($handle, $custConf);
		fclose($handle);
	}
	
	protected static function _getCustomConf($view,$fieldid,$viewid)
	{
		$path = self::_getConfPath($view,$fieldid,$viewid);
		if(!file_exists($path))
			return false;
		try{
			$ret = file_get_contents($path);
		}catch(Exception $ex){
			$ret = null;
		}
		return $ret;
	}
}
?>
